Codeforces551B:ZgukistringZ

Professor GukiZ doesn‘t accept string as they are. He likes to swap some letters in string to obtain a new one.

GukiZ has strings ab,
and c. He wants to obtain string k by
swapping some letters in a, so that k should
contain as many non-overlapping substrings equal either to b or c as
possible. Substring of string x is a string formed by consecutive segment of characters from x.
Two substrings of string x overlap if there is position i in
string x occupied by both of them.

GukiZ was disappointed because none of his students managed to solve the problem. Can you help them and find one of possible stringsk?

Input

The first line contains string a, the second line contains string b,
and the third line contains string c (1?≤?|a|,?|b|,?|c|?≤?105,
where |s|denotes the length of string s).

All three strings consist only of lowercase English letters.

It is possible that b and c coincide.

Output

Find one of possible strings k, as described in the problem statement. If there are multiple possible answers, print any of them.

Sample test(s)

input

aaa
a
b

output

aaa

input

pozdravstaklenidodiri
niste
dobri

output

nisteaadddiiklooprrvz

input

abbbaaccca
ab
aca

output

ababacabcc

Note

In the third sample, this optimal solutions has three non-overlaping substrings equal to either b or c on
positions 1?–?2 (ab), 3?–?4 (ab),5?–?7 (aca).
In this sample, there exist many other optimal solutions, one of them would be acaababbcc.

题意:

给出一个3个串s1,s2,s3要求改变s1串字母的位置,使得s2,s3在在改变后的串出现的总次数尽量多,而且不算重叠部分

思路:

先枚举其中一串出现的次数,然后计算不同情况下另外一串能出现的最大次数,最后看总次数最大的情况

#include <iostream>
#include <stdio.h>
#include <string.h>
#include <string>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <vector>
#include <math.h>
#include <bitset>
#include <list>
#include <algorithm>
#include <climits>
using namespace std;

#define lson 2*i
#define rson 2*i+1
#define LS l,mid,lson
#define RS mid+1,r,rson
#define UP(i,x,y) for(i=x;i<=y;i++)
#define DOWN(i,x,y) for(i=x;i>=y;i--)
#define MEM(a,x) memset(a,x,sizeof(a))
#define W(a) while(a)
#define gcd(a,b) __gcd(a,b)
#define LL long long
#define N 100005
#define INF 0x3f3f3f3f
#define EXP 1e-8
#define lowbit(x) (x&-x)
const int mod = 1e9+7;

char s1[N],s2[N],s3[N];
int len1,len2,len3;
int h1[30],h2[30],h3[30];
int cnt2,cnt3,cnt;

int main()
{
    int i,j,k;
    while(~scanf("%s%s%s",s1,s2,s3))
    {
        len1 = strlen(s1);
        len2 = strlen(s2);
        len3 = strlen(s3);
        MEM(h1,0);
        MEM(h2,0);
        MEM(h3,0);
        for(i = 0; i<len1; i++)
            h1[s1[i]-'a']++;
        for(i = 0; i<len2; i++)
            h2[s2[i]-'a']++;
        for(i = 0; i<len3; i++)
            h3[s3[i]-'a']++;
        cnt = 0;

        for(i=1;; i++)
        {
            int p = N;
            for(j = 0; j<26; j++)
            {
                if(h1[j]-h2[j]*i<0)
                {
                    p=0;
                    break;
                }
            }
            if(!p) break;
            int p2 = N;
            for(j = 0; j<26; j++)
            {
                if(h3[j])
                {
                    p2 = min(p2,(h1[j]-h2[j]*i)/h3[j]);
                }
            }
            if(i+p2>cnt)
            {
                cnt = i+p2;
                cnt2 = i;
                cnt3 = p2;
            }
        }
        for(i=1;; i++)
        {
            int p = N;
            for(j = 0; j<26; j++)
            {
                if(h1[j]-h3[j]*i<0)
                {
                    p=0;
                    break;
                }
            }
            if(!p) break;
            int p2 = N;
            for(j = 0; j<26; j++)
            {
                if(h2[j])
                {
                    p2 = min(p2,(h1[j]-h3[j]*i)/h2[j]);
                }
            }
            if(i+p2>cnt)
            {
                cnt = i+p2;
                cnt3 = i;
                cnt2 = p2;
            }
        }
        for(i = 0; i<cnt2; i++)
            printf("%s",s2);
        for(i = 0; i<cnt3; i++)
            printf("%s",s3);
        for(i = 0; i<26; i++)
        {
            for(j = 0; j<h1[i]-cnt2*h2[i]-cnt3*h3[i]; j++)
                printf("%c",i+'a');
        }
        printf("\n");
    }

    return 0;
}
时间: 2024-12-14 18:43:02

Codeforces551B:ZgukistringZ的相关文章

字符串处理/贪心 Codeforces Round #307 (Div. 2) B. ZgukistringZ

题目传送门 1 /* 2 题意:任意排列第一个字符串,使得有最多的不覆盖a/b字符串出现 3 字符串处理/贪心:暴力找到最大能不覆盖的a字符串,然后在b字符串中动态得出最优解 4 恶心死我了,我最初想输出最多的a,再最多的b,然而并不能保证是最多的:( 5 */ 6 #include <cstdio> 7 #include <cstring> 8 #include <string> 9 #include <iostream> 10 #include <

Codeforces Round #307 (Div. 2) B. ZgukistringZ

Professor GukiZ doesn't accept string as they are. He likes to swap some letters in string to obtain a new one. GukiZ has strings a, b, and c. He wants to obtain string k by swapping some letters in a, so that k should contain as many non-overlapping